/**********************************************************************
  WX^_v
  $Id:$
**********************************************************************/
#include "common.h"
#include "ppcsim.h"
#include "processor.h"
#include "funcs.h"
#include "memory.h"

int	print_regs( struct MACHINE_RESOURCE *mres, int flag )
{
int i,j ;
  
  fprintf(simmsgfp,"PC   : %08x\n",mres->pc) ;
  fprintf(simmsgfp,"CR   : %01x %01x %01x %01x %01x %01x %01x %01x\n",
	  mres->FLGR.cr[0]>>28,
	  mres->FLGR.cr[1]>>28,
	  mres->FLGR.cr[2]>>28,
	  mres->FLGR.cr[3]>>28,
	  mres->FLGR.cr[4]>>28,
	  mres->FLGR.cr[5]>>28,
	  mres->FLGR.cr[6]>>28,
	  mres->FLGR.cr[7]>>28) ;
  fprintf(simmsgfp,"XER  : %08x\n",mres->FLGR.xer) ;
  fprintf(simmsgfp,"LR   : %08x\n",mres->FLGR.lrl) ;
  fprintf(simmsgfp,"CTR  : %08x\n",mres->FLGR.ctrl) ;
  fprintf(simmsgfp,"GPR  : \n") ;
  fprintf(simmsgfp,"00-07: %08x %08x %08x %08x %08x %08x %08x %08x\n",
	  mres->GPR[ 0].rl,
	  mres->GPR[ 1].rl,
	  mres->GPR[ 2].rl,
	  mres->GPR[ 3].rl,
	  mres->GPR[ 4].rl,
	  mres->GPR[ 5].rl,
	  mres->GPR[ 6].rl,
	  mres->GPR[ 7].rl) ;
  fprintf(simmsgfp,"08-15: %08x %08x %08x %08x %08x %08x %08x %08x\n",
	  mres->GPR[ 8].rl,
	  mres->GPR[ 9].rl,
	  mres->GPR[10].rl,
	  mres->GPR[11].rl,
	  mres->GPR[12].rl,
	  mres->GPR[13].rl,
	  mres->GPR[14].rl,
	  mres->GPR[15].rl) ;
  fprintf(simmsgfp,"16-23: %08x %08x %08x %08x %08x %08x %08x %08x\n",
	  mres->GPR[16].rl,
	  mres->GPR[17].rl,
	  mres->GPR[18].rl,
	  mres->GPR[19].rl,
	  mres->GPR[20].rl,
	  mres->GPR[21].rl,
	  mres->GPR[22].rl,
	  mres->GPR[23].rl) ;
  fprintf(simmsgfp,"24-31: %08x %08x %08x %08x %08x %08x %08x %08x\n",
	  mres->GPR[24].rl,
	  mres->GPR[25].rl,
	  mres->GPR[26].rl,
	  mres->GPR[27].rl,
	  mres->GPR[28].rl,
	  mres->GPR[29].rl,
	  mres->GPR[30].rl,
	  mres->GPR[31].rl) ;
  
  if( flag==PRINT_ALLREGISTERS ){
    /* CPUA[LeN`ˑǂ̂..... */
    unsigned int *fpr_u, *fpr_l ;
    
    fprintf(simmsgfp,"FPR  : \n") ;
    for( i=0 ; i<8 ; i++ ){
      fprintf(simmsgfp,"%02d-%02d: ",i*4,i*4+3) ;
      for( j=0 ; j<4 ; j++ ){
#ifdef LITTLE_ENDIAN
	fpr_l=(unsigned int*)&mres->FPR[i*4+j].f ;
	fpr_u=fpr_l+1 ;
#else
	fpr_u=&mres->FPR[i*4+j].f ;
	fpr_l=fpr_u+1 ;
#endif
	fprintf(simmsgfp,"%08x%08x  ",*fpr_u,*fpr_l) ;
      }
      fprintf(simmsgfp,"\n") ;
    }
  }
 return(NORMAL_EXIT) ;
}
